#!/usr/bin/perl -w

# Generate structure with md5 sums for the stored procedures given.

use Digest::MD5 qw(md5 md5_hex md5_base64);

use strict;
use warnings;

my $inbody = 0;
my $func = 0;
my $body;
my %md5sums;

while (<>) {
    
    /^CREATE OR REPLACE FUNCTION ([A-Za-z0-9_]*)[[:space:]]*\(/ && do {
	if ($func) {
	    $md5sums{$func} = md5_hex($body);
	}
	die ("Duplicate stored procedure detected: " . $1)
		if (defined($md5sums{$1}));
	$func = $1;
	$body = '';
    };
    
    if (!$inbody && /(\$(zzz)?\$)/) {
        # Assign $1 with all $ signs replaced with \$ to $inbody.
        ($inbody = $1) =~ s/\$/\\\$/g;
        s/.*${inbody}//;
	$body .= $_;
    }
    # Look for end quote matching start quote symbol
    elsif ($inbody && /$inbody/) {
	s/${inbody}.*\n?//;
	$inbody = 0;
	$body .= $_;
    }
    elsif ($inbody) {
	$body .= $_;
    }
}

if ($func) {
    $md5sums{$func} = md5_hex($body);
}

print "/* This file is auto generated by generate_proc_checksums.pl */

#include \"verify_proc_checksums.h\"
#include <stdlib.h>

struct stored_proc_checksum stored_procs[] = {
";

foreach $func (sort(keys(%md5sums))) {
    my $sum = $md5sums{$func};
    print "{\"$func\", \"$sum\"},\n";
}
print "{NULL, NULL}};\n";
